#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <stdarg.h>
#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <ctype.h>
#include <dlfcn.h>
#include <string.h>
#define NULLCHAR	'\000'
#define PATCH_MAX	255

typedef struct result_var {
  unsigned char Infect;
  char VName[255];
  unsigned char Rezh;
} Result_var;

// for test file
unsigned char *ArrayOfByte;
static struct stat FileStat;
// for load .so module
static char *error;
Result_var (*UnaAPITest)(unsigned char *szArrayOfBytes, unsigned long dwLENGTH);
Result_var Result_Test_File;

static char FileName [ PATCH_MAX ] ={ NULLCHAR };
static int parseCmdLine(int argc, char **argv );
static int returned;
static char *WorkPatch;
static char PatchToSO[ PATCH_MAX ];
//----------------------------------------------------------------------------------
int main (int argc, char **argv) {
void *handle;
int FileToCheck;
returned = 0;

if (!parseCmdLine(argc,argv)) 
   {
     printf ("\nUsage: testapi -f eicar.txt\nYou enter:  %s\n",FileName);
     return(1);
   };
WorkPatch = getcwd(NULL,(size_t)0);
if (WorkPatch==NULL) {fprintf (stderr, "Can not get patch to api .so module.\n");};
strcat(PatchToSO,WorkPatch);
strcat(PatchToSO,"/unamscan.so");

// open .so module
 handle = dlopen (PatchToSO, RTLD_NOW);
 if (!handle) {fputs(dlerror(),stderr);exit(1);}
// Associate UnaAPITest functions with function in .so module
 UnaAPITest = dlsym(handle, "UnaAPITest");
 if ((error = dlerror()) != NULL) { fprintf (stderr, "%s\n", error); exit(1); };

    FileToCheck = open(FileName,O_RDONLY);
    if (error != NULL) { fprintf (stderr, "%s\n", error); exit(2); };

// get test file size
    fstat(FileToCheck, &FileStat);
    ArrayOfByte = (unsigned char*)malloc(FileStat.st_size*sizeof(unsigned char));
    if (ArrayOfByte==NULL) { fprintf (stderr, "Error in malloc\n"); exit(5);};
    if (-1==read(FileToCheck, ArrayOfByte, FileStat.st_size)) 
       { printf ("Cen not read test file \n"); dlclose(handle); free(ArrayOfByte); exit(4); };
    close(FileToCheck);
    
// call functions from .so module for test
    Result_Test_File = (*UnaAPITest)(ArrayOfByte, FileStat.st_size);

if (Result_Test_File.Infect!=0) { printf ("Infected: %s\n", Result_Test_File.VName); returned =1; }

// free memory of test file
	free(ArrayOfByte);
// close .so module
	dlclose(handle);
return returned;
} // end of program.
//-----------------------------------------------------------------------------------
static int parseCmdLine (int argc, char **argv)
{
int wh_i = 1;
	if ( argc <2 )
	{
	printf("\nYou should specify parameters.");
	return 0;
	}
while (wh_i)
{
switch ( getopt(argc, argv, "+f:") ) 
{
case 'f':
	strncpy (FileName, optarg,sizeof(FileName)-1 );
	break;
case -1 :
	wh_i=0;
	break;
default :
	if (optarg)
	{
	printf ("\n Unknow options <%c>",optarg[0]);
	}
	return 0;
} // switch
}// while (wh_i);
return 1;
}
